import { IPieceProps } from '@writeaway/core';
import React, { Component } from 'react';
import { WriteAwayCodeMirrorData, WriteAwayCodeMirrorState } from 'types';
import 'prismjs/components/prism-clike';
import 'prismjs/components/prism-css';
import 'prismjs/components/prism-markup';
import 'prismjs/components/prism-javascript';
export default class CodeMirror extends Component<IPieceProps<WriteAwayCodeMirrorData>, WriteAwayCodeMirrorState> {
    /**
     * Specify component should be rendered inside target node and capture all inside html
     * @type {string}
     */
    static readonly __renderType = "BEFORE";
    static readonly editLabel = "Edit Source Code";
    static readonly label = "Source code";
    static readonly applyEditor: (node: HTMLElement, data: WriteAwayCodeMirrorData) => boolean;
    private beautifyOptions;
    state: WriteAwayCodeMirrorState;
    private modalNode;
    private initDataKeys;
    private nodeWasUpdated;
    private code;
    constructor(props: IPieceProps);
    UNSAFE_componentWillReceiveProps(newProps: IPieceProps): void;
    shouldComponentUpdate(nextProps: IPieceProps): boolean;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    updateCode(value: string): void;
    onSave(): void;
    onClose(): void;
    createEditor(): void;
    destroyEditor(): void;
    renderNonReactAttributes(): void;
    onClick(e: MouseEvent): void;
    setEditorActive(active: boolean): void;
    /**
     * That is a common public method that should activate component editor if it presents
     */
    activateEditor(): void;
    deactivateEditor(): void;
    handleCloseModal(event: React.MouseEvent | React.KeyboardEvent): void;
    render(): any;
}
